Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/libyahoo2.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -1214,33 +1146,37 @@
 	}
 
-	switch(pkt->service) {
+	switch (pkt->service) {
 	case YAHOO_SERVICE_CHATJOIN:
-		if(y_list_length(members) != membercount) {
+		if (y_list_length(members) != membercount) {
 			WARNING(("Count of members doesn't match No. of members we got"));
 		}
-		if(firstjoin && members) {
-			YAHOO_CALLBACK(ext_yahoo_chat_join)(yid->yd->client_id, id, room, topic, members, yid->fd);
-		} else if(who) {
-			if(y_list_length(members) != 1) {
+		if (firstjoin && members) {
+			YAHOO_CALLBACK(ext_yahoo_chat_join) (yid->yd->client_id,
+				id, room, topic, members, yid->fd);
+		} else if (who) {
+			if (y_list_length(members) != 1) {
 				WARNING(("Got more than 1 member on a normal join"));
 			}
 			/* this should only ever have one, but just in case */
-			while(members) {
+			while (members) {
 				YList *n = members->next;
 				currentmember = members->data;
-				YAHOO_CALLBACK(ext_yahoo_chat_userjoin)(yid->yd->client_id, id, room, currentmember);
+				YAHOO_CALLBACK(ext_yahoo_chat_userjoin) (yid->
+					yd->client_id, id, room, currentmember);
 				y_list_free_1(members);
-				members=n;
+				members = n;
 			}
 		}
 		break;
 	case YAHOO_SERVICE_CHATEXIT:
-		if(who) {
-			YAHOO_CALLBACK(ext_yahoo_chat_userleave)(yid->yd->client_id, id, room, who);
+		if (who) {
+			YAHOO_CALLBACK(ext_yahoo_chat_userleave) (yid->yd->
+				client_id, id, room, who);
 		}
 		break;
 	case YAHOO_SERVICE_COMMENT:
-		if(who) {
-			YAHOO_CALLBACK(ext_yahoo_chat_message)(yid->yd->client_id, id, who, room, msg, msgtype, utf8);
+		if (who) {
+			YAHOO_CALLBACK(ext_yahoo_chat_message) (yid->yd->
+				client_id, id, who, room, msg, msgtype, utf8);
 		}
 		break;
@@ -1248,28 +1184,28 @@
 }
 
-static void yahoo_process_message(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_message(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
 	YList *l;
-	YList * messages = NULL;
+	YList *messages = NULL;
 
 	struct m {
-		int  i_31;
-		int  i_32;
+		int i_31;
+		int i_32;
 		char *to;
 		char *from;
 		long tm;
 		char *msg;
-		int  utf8;
+		int utf8;
+		char *gunk;
 	} *message = y_new0(struct m, 1);
 
 	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
-		if (pair->key == 1 || pair->key == 4)
-		{
-			if(!message->from)
+		if (pair->key == 1 || pair->key == 4) {
+			if (!message->from)
 				message->from = pair->value;
-		}
-		else if (pair->key == 5)
+		} else if (pair->key == 5)
 			message->to = pair->value;
 		else if (pair->key == 15)
@@ -1277,33 +1213,59 @@
 		else if (pair->key == 97)
 			message->utf8 = atoi(pair->value);
-			/* user message */  /* sys message */
+		/* This comes when the official client sends us a message */
+		else if (pair->key == 429)
+			message->gunk = pair->value;
+		/* user message *//* sys message */
 		else if (pair->key == 14 || pair->key == 16)
 			message->msg = pair->value;
 		else if (pair->key == 31) {
-			if(message->i_31) {
+			if (message->i_31) {
 				messages = y_list_append(messages, message);
 				message = y_new0(struct m, 1);
 			}
 			message->i_31 = atoi(pair->value);
-		}
-		else if (pair->key == 32)
+		} else if (pair->key == 32)
 			message->i_32 = atoi(pair->value);
 		else
-			LOG(("yahoo_process_message: status: %d, key: %d, value: %s",
-					pkt->status, pair->key, pair->value));
+			LOG(("yahoo_process_message: status: %d, key: %d, value: %s", pkt->status, pair->key, pair->value));
 	}
 
 	messages = y_list_append(messages, message);
 
-	for (l = messages; l; l=l->next) {
+	for (l = messages; l; l = l->next) {
 		message = l->data;
 		if (pkt->service == YAHOO_SERVICE_SYSMESSAGE) {
-			YAHOO_CALLBACK(ext_yahoo_system_message)(yd->client_id, message->msg);
+			YAHOO_CALLBACK(ext_yahoo_system_message) (yd->client_id,
+				message->to, message->from, message->msg);
 		} else if (pkt->status <= 2 || pkt->status == 5) {
-			YAHOO_CALLBACK(ext_yahoo_got_im)(yd->client_id, message->to, message->from, message->msg, message->tm, pkt->status, message->utf8);
+			/* Confirm message receipt if we got the gunk */
+			if(message->gunk) {
+				struct yahoo_packet *outpkt;
+                        
+				outpkt = yahoo_packet_new(YAHOO_SERVICE_MESSAGE_CONFIRM,
+					YPACKET_STATUS_DEFAULT, 0);
+				yahoo_packet_hash(outpkt, 1, yd->user);
+				yahoo_packet_hash(outpkt, 5, message->from);
+				yahoo_packet_hash(outpkt, 302, "430");
+				yahoo_packet_hash(outpkt, 430, message->gunk);
+				yahoo_packet_hash(outpkt, 303, "430");
+				yahoo_packet_hash(outpkt, 450, "0");
+				yahoo_send_packet(yid, outpkt, 0);
+                        
+				yahoo_packet_free(outpkt);
+			}
+
+			if (!strcmp(message->msg, "<ding>"))
+				YAHOO_CALLBACK(ext_yahoo_got_buzz) (yd->client_id,
+					message->to, message->from, message->tm);
+			else
+				YAHOO_CALLBACK(ext_yahoo_got_im) (yd->client_id,
+					message->to, message->from, message->msg,
+					message->tm, pkt->status, message->utf8);
 		} else if (pkt->status == 0xffffffff) {
-			YAHOO_CALLBACK(ext_yahoo_error)(yd->client_id, message->msg, 0, E_SYSTEM);
-		}
-		free(message);
+			YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id,
+				message->msg, 0, E_SYSTEM);
+		}
+		FREE(message);
 	}
 
@@ -1311,4 +1273,27 @@
 }
 
+/*
+ * Here's what multi-level packets look like. Data in brackets is the value.
+ *
+ * 3 level:
+ * =======
+ * 
+ * 302 (318) - Beginning level 1
+ * 	300 (318) - Begin level 2
+ * 	302 (319) - End level 2 header
+ * 		300 (319) - Begin level 3
+ * 		301 (319) - End level 3
+ * 	303 (319) - End level 2
+ * 303 (318) - End level 1
+ *
+ * 2 level:
+ * =======
+ *
+ * 302 (315) - Beginning level 1
+ * 	300 (315) - Begin level 2
+ * 	301 (315) - End level 2
+ * 303 (315) - End level 1
+ *
+ */
 static void yahoo_process_status(struct yahoo_input_data *yid,
 	struct yahoo_packet *pkt)
@@ -1327,8 +1312,10 @@
 	}
 
-	/* Status updates may be spread accross multiple packets and not
-	   even on buddy boundaries, so keeping some state is important.
-	   So, continue where we left off, and only add a user entry to
-	   the list once it's complete (301-315 End buddy). */
+	/* 
+	 * Status updates may be spread accross multiple packets and not 
+	 * even on buddy boundaries, so keeping some state is important. 
+	 * So, continue where we left off, and only add a user entry to 
+	 * the list once it's complete (301-315 End buddy).
+	 */
 	u = yd->half_user;
 
@@ -1594,15 +1581,18 @@
 }
 
-static void yahoo_process_verify(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_verify(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
 
-	if(pkt->status != 0x01) {
+	if (pkt->status != 0x01) {
 		DEBUG_MSG(("expected status: 0x01, got: %d", pkt->status));
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, YAHOO_LOGIN_LOCK, "");
-		return;
-	}
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YAHOO_STATUS_AVAILABLE, yd->session_id);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			YAHOO_LOGIN_LOCK, "");
+		return;
+	}
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 
 	yahoo_packet_hash(pkt, 1, yd->user);
@@ -1613,5 +1603,6 @@
 }
 
-static void yahoo_process_picture_checksum( struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_picture_checksum(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -1621,28 +1612,28 @@
 	YList *l;
 
-	for(l = pkt->hash; l; l = l->next)
-	{
+	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 
-		switch(pair->key)
-		{
-			case 1:
-			case 4:
-				from = pair->value;
-			case 5:
-				to = pair->value;
-				break;
-			case 212:
-				break;
-			case 192:
-				checksum = atoi( pair->value );
-				break;
-		}
-	}
-
-	YAHOO_CALLBACK(ext_yahoo_got_buddyicon_checksum)(yd->client_id,to,from,checksum);
-}
-
-static void yahoo_process_picture(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		switch (pair->key) {
+		case 1:
+		case 4:
+			from = pair->value;
+		case 5:
+			to = pair->value;
+			break;
+		case 212:
+			break;
+		case 192:
+			checksum = atoi(pair->value);
+			break;
+		}
+	}
+
+	YAHOO_CALLBACK(ext_yahoo_got_buddyicon_checksum) (yd->client_id, to,
+		from, checksum);
+}
+
+static void yahoo_process_picture(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -1653,42 +1644,42 @@
 	int checksum = 0;
 	YList *l;
-	
-	for(l = pkt->hash; l; l = l->next)
-	{
+
+	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 
-		switch(pair->key)
-		{
+		switch (pair->key) {
 		case 1:
-		case 4:		/* sender */
+		case 4:	/* sender */
 			from = pair->value;
 			break;
-		case 5:		/* we */
+		case 5:	/* we */
 			to = pair->value;
 			break;
-		case 13:		/* request / sending */
-			status = atoi( pair->value );
-			break;
-		case 20:		/* url */
+		case 13:	/* request / sending */
+			status = atoi(pair->value);
+			break;
+		case 20:	/* url */
 			url = pair->value;
 			break;
 		case 192:	/*checksum */
-			checksum = atoi( pair->value );
-			break;
-		}
-	}
-
-	switch( status )
-	{
-		case 1:	/* this is a request, ignore for now */
-			YAHOO_CALLBACK(ext_yahoo_got_buddyicon_request)(yd->client_id, to, from);
-			break;
-		case 2:	/* this is cool - we get a picture :) */
-			YAHOO_CALLBACK(ext_yahoo_got_buddyicon)(yd->client_id,to, from, url, checksum);
-			break;
-	}
-}
-
-static void yahoo_process_picture_upload(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+			checksum = atoi(pair->value);
+			break;
+		}
+	}
+
+	switch (status) {
+	case 1:		/* this is a request, ignore for now */
+		YAHOO_CALLBACK(ext_yahoo_got_buddyicon_request) (yd->client_id,
+			to, from);
+		break;
+	case 2:		/* this is cool - we get a picture :) */
+		YAHOO_CALLBACK(ext_yahoo_got_buddyicon) (yd->client_id, to,
+			from, url, checksum);
+		break;
+	}
+}
+
+static void yahoo_process_picture_upload(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -1696,562 +1687,63 @@
 	char *url = NULL;
 
-	if ( pkt->status != 1 )
+	if (pkt->status != 1)
 		return;		/* something went wrong */
-	
-	for(l = pkt->hash; l; l = l->next)
-	{
+
+	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 
-		switch(pair->key)
-		{
-			case 5:		/* we */
-				break;
-			case 20:		/* url */
-				url = pair->value;
-				break;
-			case 27:		/* local filename */
-				break;
-			case 38:		/* time */
-				break;
-		}
-	}
-
-	YAHOO_CALLBACK(ext_yahoo_buddyicon_uploaded)(yd->client_id, url);
-}
-
-static void yahoo_process_auth_pre_0x0b(struct yahoo_input_data *yid, 
-		const char *seed, const char *sn)
-{
-	struct yahoo_data *yd = yid->yd;
-	
-	/* So, Yahoo has stopped supporting its older clients in India, and 
-	 * undoubtedly will soon do so in the rest of the world.
-	 * 
-	 * The new clients use this authentication method.  I warn you in 
-	 * advance, it's bizzare, convoluted, inordinately complicated.  
-	 * It's also no more secure than crypt() was.  The only purpose this 
-	 * scheme could serve is to prevent third part clients from connecting 
-	 * to their servers.
-	 *
-	 * Sorry, Yahoo.
+		switch (pair->key) {
+		case 5:	/* we */
+			break;
+		case 20:	/* url */
+			url = pair->value;
+			break;
+		case 27:	/* local filename */
+			break;
+		case 38:	/* time */
+			break;
+		}
+	}
+
+	YAHOO_CALLBACK(ext_yahoo_buddyicon_uploaded) (yd->client_id, url);
+}
+
+void yahoo_login(int id, int initial)
+{
+	struct yahoo_data *yd = find_conn_by_id(id);
+	struct connect_callback_data *ccd;
+	struct yahoo_server_settings *yss;
+	int tag;
+
+	char *host;
+
+	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
+	yid->yd = yd;
+	yid->type = YAHOO_CONNECTION_PAGER;
+	inputs = y_list_prepend(inputs, yid);
+
+	yd->initial_status = initial;
+	yss = yd->server_settings;
+
+	ccd = y_new0(struct connect_callback_data, 1);
+	ccd->yd = yd;
+
+	host = yss->pager_host;
+
+	if (!host)
+		host = yss->pager_host_list[0];
+
+	tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->client_id,
+		host, yss->pager_port, yahoo_connected, ccd, 0);
+
+	/*
+	 * if tag <= 0, then callback has already been called
+	 * so ccd will have been freed
 	 */
-
-	struct yahoo_packet *pack;
-	
-	md5_byte_t result[16];
-	md5_state_t ctx;
-	char *crypt_result;
-	unsigned char *password_hash = malloc(25);
-	unsigned char *crypt_hash = malloc(25);
-	unsigned char *hash_string_p = malloc(50 + strlen(sn));
-	unsigned char *hash_string_c = malloc(50 + strlen(sn));
-	
-	char checksum;
-	
-	int sv;
-	
-	unsigned char *result6 = malloc(25);
-	unsigned char *result96 = malloc(25);
-
-	sv = seed[15];
-	sv = (sv % 8) % 5;
-
-	md5_init(&ctx);
-	md5_append(&ctx, (md5_byte_t *)yd->password, strlen(yd->password));
-	md5_finish(&ctx, result);
-	to_y64(password_hash, result, 16);
-	
-	md5_init(&ctx);
-	crypt_result = yahoo_crypt(yd->password, "$1$_2S43d5f$");  
-	md5_append(&ctx, (md5_byte_t *)crypt_result, strlen(crypt_result));
-	md5_finish(&ctx, result);
-	to_y64(crypt_hash, result, 16);
-	free(crypt_result);
-
-	switch (sv) {
-	case 0:
-		checksum = seed[seed[7] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, password_hash, yd->user, seed);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, crypt_hash, yd->user, seed);
-		break;
-	case 1:
-		checksum = seed[seed[9] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, seed, password_hash);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, seed, crypt_hash);
-		break;
-	case 2:
-		checksum = seed[seed[15] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, seed, password_hash, yd->user);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, seed, crypt_hash, yd->user);
-		break;
-	case 3:
-		checksum = seed[seed[1] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, password_hash, seed);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, yd->user, crypt_hash, seed);
-		break;
-	case 4:
-		checksum = seed[seed[3] % 16];
-		snprintf((char *)hash_string_p, strlen(sn) + 50,
-			"%c%s%s%s", checksum, password_hash, seed, yd->user);
-		snprintf((char *)hash_string_c, strlen(sn) + 50,
-			"%c%s%s%s", checksum, crypt_hash, seed, yd->user);
-		break;
-	}
-		
-	md5_init(&ctx);  
-	md5_append(&ctx, (md5_byte_t *)hash_string_p, strlen((char *)hash_string_p));
-	md5_finish(&ctx, result);
-	to_y64(result6, result, 16);
-
-	md5_init(&ctx);  
-	md5_append(&ctx, (md5_byte_t *)hash_string_c, strlen((char *)hash_string_c));
-	md5_finish(&ctx, result);
-	to_y64(result96, result, 16);
-
-	pack = yahoo_packet_new(YAHOO_SERVICE_AUTHRESP, yd->initial_status, yd->session_id);
-	yahoo_packet_hash(pack, 0, yd->user);
-	yahoo_packet_hash(pack, 6, (char *)result6);
-	yahoo_packet_hash(pack, 96, (char *)result96);
-	yahoo_packet_hash(pack, 1, yd->user);
-		
-	yahoo_send_packet(yid, pack, 0);
-		
-	FREE(result6);
-	FREE(result96);
-	FREE(password_hash);
-	FREE(crypt_hash);
-	FREE(hash_string_p);
-	FREE(hash_string_c);
-
-	yahoo_packet_free(pack);
-
-}
-
-/*
- * New auth protocol cracked by Cerulean Studios and sent in to Gaim
- */
-static void yahoo_process_auth_0x0b(struct yahoo_input_data *yid, const char *seed, const char *sn)
-{
-	struct yahoo_packet *pack = NULL;
-	struct yahoo_data *yd = yid->yd;
-
-	md5_byte_t         result[16];
-	md5_state_t        ctx;
-
-	sha1_state_t       ctx1;
-	sha1_state_t       ctx2;
-
-	char *alphabet1 = "FBZDWAGHrJTLMNOPpRSKUVEXYChImkwQ";
-	char *alphabet2 = "F0E1D2C3B4A59687abcdefghijklmnop";
-
-	char *challenge_lookup = "qzec2tb3um1olpar8whx4dfgijknsvy5";
-	char *operand_lookup = "+|&%/*^-";
-	char *delimit_lookup = ",;";
-
-	unsigned char *password_hash = malloc(25);
-	unsigned char *crypt_hash = malloc(25);
-	char *crypt_result = NULL;
-	unsigned char pass_hash_xor1[64];
-	unsigned char pass_hash_xor2[64];
-	unsigned char crypt_hash_xor1[64];
-	unsigned char crypt_hash_xor2[64];
-	unsigned char chal[7];
-	char resp_6[100];
-	char resp_96[100];
-
-	unsigned char digest1[20];
-	unsigned char digest2[20];
-	unsigned char magic_key_char[4];
-	const unsigned char *magic_ptr;
-
-	unsigned int  magic[64];
-	unsigned int  magic_work=0;
-
-	char comparison_src[20];
-
-	int x, j, i;
-	int cnt = 0;
-	int magic_cnt = 0;
-	int magic_len;
-	int depth =0, table =0;
-
-	memset(&pass_hash_xor1, 0, 64);
-	memset(&pass_hash_xor2, 0, 64);
-	memset(&crypt_hash_xor1, 0, 64);
-	memset(&crypt_hash_xor2, 0, 64);
-	memset(&digest1, 0, 20);
-	memset(&digest2, 0, 20);
-	memset(&magic, 0, 64);
-	memset(&resp_6, 0, 100);
-	memset(&resp_96, 0, 100);
-	memset(&magic_key_char, 0, 4);
-
-	/* 
-	 * Magic: Phase 1.  Generate what seems to be a 30 
-	 * byte value (could change if base64
-	 * ends up differently?  I don't remember and I'm 
-	 * tired, so use a 64 byte buffer.
-	 */
-
-	magic_ptr = (unsigned char *)seed;
-
-	while (*magic_ptr != 0) {
-		char *loc;
-
-		/* Ignore parentheses.  */
-
-		if (*magic_ptr == '(' || *magic_ptr == ')') {
-			magic_ptr++;
-			continue;
-		}
-
-		/* Characters and digits verify against 
-		   the challenge lookup.
-		*/
-
-		if (isalpha(*magic_ptr) || isdigit(*magic_ptr)) {
-			loc = strchr(challenge_lookup, *magic_ptr);
-			if (!loc) {
-				/* This isn't good */
-				continue;
-			}
-
-			/* Get offset into lookup table and lsh 3. */
-
-			magic_work = loc - challenge_lookup;
-			magic_work <<= 3;
-
-			magic_ptr++;
-			continue;
-		} else {
-			unsigned int local_store;
-
-			loc = strchr(operand_lookup, *magic_ptr);
-			if (!loc) {
-				/* Also not good. */
-				continue;
-			}
-
-			local_store = loc - operand_lookup;
-
-			/* Oops; how did this happen? */
-			if (magic_cnt >= 64) 
-				break;
-
-			magic[magic_cnt++] = magic_work | local_store;
-			magic_ptr++;
-			continue;
-		}
-	}
-
-	magic_len = magic_cnt;
-	magic_cnt = 0;
-
-	/* Magic: Phase 2.  Take generated magic value and 
-	 * sprinkle fairy dust on the values. */
-
-	for (magic_cnt = magic_len-2; magic_cnt >= 0; magic_cnt--) {
-		unsigned char byte1;
-		unsigned char byte2;
-
-		/* Bad.  Abort.
-		 */
-		if (magic_cnt >= magic_len) {
-			WARNING(("magic_cnt(%d)  magic_len(%d)", magic_cnt, magic_len))
-			break;
-		}
-
-		byte1 = magic[magic_cnt];
-		byte2 = magic[magic_cnt+1];
-
-		byte1 *= 0xcd;
-		byte1 ^= byte2;
-
-		magic[magic_cnt+1] = byte1;
-	}
-
-	/* Magic: Phase 3.  This computes 20 bytes.  The first 4 bytes are used as our magic 
-	 * key (and may be changed later); the next 16 bytes are an MD5 sum of the magic key 
-	 * plus 3 bytes.  The 3 bytes are found by looping, and they represent the offsets 
-	 * into particular functions we'll later call to potentially alter the magic key. 
-	 * 
-	 * %-) 
-	 */ 
-	
-	magic_cnt = 1; 
-	x = 0; 
-	
-	do { 
-		unsigned int     bl = 0;  
-		unsigned int     cl = magic[magic_cnt++]; 
-		
-		if (magic_cnt >= magic_len) 
-			break; 
-		
-		if (cl > 0x7F) { 
-			if (cl < 0xe0)  
-				bl = cl = (cl & 0x1f) << 6;  
-			else { 
-				bl = magic[magic_cnt++];  
-                              cl = (cl & 0x0f) << 6;  
-                              bl = ((bl & 0x3f) + cl) << 6;  
-			}  
-			
-			cl = magic[magic_cnt++];  
-			bl = (cl & 0x3f) + bl;  
-		} else 
-			bl = cl;  
-		
-		comparison_src[x++] = (bl & 0xff00) >> 8;  
-		comparison_src[x++] = bl & 0xff;  
-	} while (x < 20); 
-
-	/* Dump magic key into a char for SHA1 action. */
-	
-		
-	for(x = 0; x < 4; x++) 
-		magic_key_char[x] = comparison_src[x];
-
-	/* Compute values for recursive function table! */
-	memcpy( chal, magic_key_char, 4 );
-        x = 1;
-	for( i = 0; i < 0xFFFF && x; i++ )
-	{
-		for( j = 0; j < 5 && x; j++ )
-		{
-			chal[4] = i;
-			chal[5] = i >> 8;
-			chal[6] = j;
-			md5_init( &ctx );
-			md5_append( &ctx, chal, 7 );
-			md5_finish( &ctx, result );
-			if( memcmp( comparison_src + 4, result, 16 ) == 0 )
-			{
-				depth = i;
-				table = j;
-				x = 0;
-			}
-		}
-	}
-
-	/* Transform magic_key_char using transform table */
-	x = magic_key_char[3] << 24  | magic_key_char[2] << 16 
-		| magic_key_char[1] << 8 | magic_key_char[0];
-	x = yahoo_xfrm( table, depth, x );
-	x = yahoo_xfrm( table, depth, x );
-	magic_key_char[0] = x & 0xFF;
-	magic_key_char[1] = x >> 8 & 0xFF;
-	magic_key_char[2] = x >> 16 & 0xFF;
-	magic_key_char[3] = x >> 24 & 0xFF;
-
-	/* Get password and crypt hashes as per usual. */
-	md5_init(&ctx);
-	md5_append(&ctx, (md5_byte_t *)yd->password,  strlen(yd->password));
-	md5_finish(&ctx, result);
-	to_y64(password_hash, result, 16);
-
-	md5_init(&ctx);
-	crypt_result = yahoo_crypt(yd->password, "$1$_2S43d5f$");  
-	md5_append(&ctx, (md5_byte_t *)crypt_result, strlen(crypt_result));
-	md5_finish(&ctx, result);
-	to_y64(crypt_hash, result, 16);
-	free(crypt_result);
-
-	/* Our first authentication response is based off 
-	 * of the password hash. */
-
-	for (x = 0; x < (int)strlen((char *)password_hash); x++) 
-		pass_hash_xor1[cnt++] = password_hash[x] ^ 0x36;
-
-	if (cnt < 64) 
-		memset(&(pass_hash_xor1[cnt]), 0x36, 64-cnt);
-
-	cnt = 0;
-
-	for (x = 0; x < (int)strlen((char *)password_hash); x++) 
-		pass_hash_xor2[cnt++] = password_hash[x] ^ 0x5c;
-
-	if (cnt < 64) 
-		memset(&(pass_hash_xor2[cnt]), 0x5c, 64-cnt);
-
-	sha1_init(&ctx1);
-	sha1_init(&ctx2);
-
-	/* The first context gets the password hash XORed 
-	 * with 0x36 plus a magic value
-	 * which we previously extrapolated from our 
-	 * challenge. */
-
-	sha1_append(&ctx1, pass_hash_xor1, 64);
-	if (j >= 3 )
-		ctx1.Length_Low = 0x1ff;
-	sha1_append(&ctx1, magic_key_char, 4);
-	sha1_finish(&ctx1, digest1);
-
-	 /* The second context gets the password hash XORed 
-	  * with 0x5c plus the SHA-1 digest
-	  * of the first context. */
-
-	sha1_append(&ctx2, pass_hash_xor2, 64);
-	sha1_append(&ctx2, digest1, 20);
-	sha1_finish(&ctx2, digest2);
-
-	/* Now that we have digest2, use it to fetch 
-	 * characters from an alphabet to construct
-	 * our first authentication response. */
-
-	for (x = 0; x < 20; x += 2) {
-		unsigned int    val = 0;
-		unsigned int    lookup = 0;
-		char            byte[6];
-
-		memset(&byte, 0, 6);
-
-		/* First two bytes of digest stuffed 
-		 *  together.
-		 */
-
-		val = digest2[x];
-		val <<= 8;
-		val += digest2[x+1];
-
-		lookup = (val >> 0x0b);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet1))
-			break;
-		sprintf(byte, "%c", alphabet1[lookup]);
-		strcat(resp_6, byte);
-		strcat(resp_6, "=");
-
-		lookup = (val >> 0x06);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_6, byte);
-
-		lookup = (val >> 0x01);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_6, byte);
-
-		lookup = (val & 0x01);
-		if (lookup >= strlen(delimit_lookup))
-			break;
-		sprintf(byte, "%c", delimit_lookup[lookup]);
-		strcat(resp_6, byte);
-	}
-
-	/* Our second authentication response is based off 
-	 * of the crypto hash. */
-
-	cnt = 0;
-	memset(&digest1, 0, 20);
-	memset(&digest2, 0, 20);
-
-	for (x = 0; x < (int)strlen((char *)crypt_hash); x++) 
-		crypt_hash_xor1[cnt++] = crypt_hash[x] ^ 0x36;
-
-	if (cnt < 64) 
-		memset(&(crypt_hash_xor1[cnt]), 0x36, 64-cnt);
-
-	cnt = 0;
-
-	for (x = 0; x < (int)strlen((char *)crypt_hash); x++) 
-		crypt_hash_xor2[cnt++] = crypt_hash[x] ^ 0x5c;
-
-	if (cnt < 64) 
-		memset(&(crypt_hash_xor2[cnt]), 0x5c, 64-cnt);
-
-	sha1_init(&ctx1);
-	sha1_init(&ctx2);
-
-	/* The first context gets the password hash XORed 
-	 * with 0x36 plus a magic value
-	 * which we previously extrapolated from our 
-	 * challenge. */
-
-	sha1_append(&ctx1, crypt_hash_xor1, 64);
-	if (j >= 3 )
-		ctx1.Length_Low = 0x1ff;
-	sha1_append(&ctx1, magic_key_char, 4);
-	sha1_finish(&ctx1, digest1);
-
-	/* The second context gets the password hash XORed 
-	 * with 0x5c plus the SHA-1 digest
-	 * of the first context. */
-
-	sha1_append(&ctx2, crypt_hash_xor2, 64);
-	sha1_append(&ctx2, digest1, 20);
-	sha1_finish(&ctx2, digest2);
-
-	/* Now that we have digest2, use it to fetch 
-	 * characters from an alphabet to construct
-	 * our first authentication response.  */
-
-	for (x = 0; x < 20; x += 2) {
-		unsigned int val = 0;
-		unsigned int lookup = 0;
-
-		char byte[6];
-
-		memset(&byte, 0, 6);
-
-		/* First two bytes of digest stuffed 
-		 *  together. */
-
-		val = digest2[x];
-		val <<= 8;
-		val += digest2[x+1];
-
-		lookup = (val >> 0x0b);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet1))
-			break;
-		sprintf(byte, "%c", alphabet1[lookup]);
-		strcat(resp_96, byte);
-		strcat(resp_96, "=");
-
-		lookup = (val >> 0x06);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_96, byte);
-
-		lookup = (val >> 0x01);
-		lookup &= 0x1f;
-		if (lookup >= strlen(alphabet2))
-			break;
-		sprintf(byte, "%c", alphabet2[lookup]);
-		strcat(resp_96, byte);
-
-		lookup = (val & 0x01);
-		if (lookup >= strlen(delimit_lookup))
-			break;
-		sprintf(byte, "%c", delimit_lookup[lookup]);
-		strcat(resp_96, byte);
-	}
-
-	pack = yahoo_packet_new(YAHOO_SERVICE_AUTHRESP, yd->initial_status, yd->session_id);
-	yahoo_packet_hash(pack, 0, sn);
-	yahoo_packet_hash(pack, 6, resp_6);
-	yahoo_packet_hash(pack, 96, resp_96);
-	yahoo_packet_hash(pack, 1, sn);
-	yahoo_send_packet(yid, pack, 0);
-	yahoo_packet_free(pack);
-
-	free(password_hash);
-	free(crypt_hash);
+	if (tag > 0)
+		ccd->tag = tag;
+	else if (tag < 0)
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			YAHOO_LOGIN_SOCK, NULL);
 }
 
@@ -2303,5 +1795,5 @@
 }
 
-static void yahoo_process_auth_0x10(struct yahoo_input_data *yid, const char *seed, const char *sn)
+static void yahoo_https_auth(struct yahoo_input_data *yid, const char *seed, const char *sn)
 {
 	struct yahoo_https_auth_data *had = g_new0(struct yahoo_https_auth_data, 1);
@@ -2353,19 +1845,20 @@
 	
 	if (req->status_code != 200) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 2000 + req->status_code, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 2000 + req->status_code, NULL);
 		goto fail;
 	}
 	
 	if (sscanf(req->reply_body, "%d", &st) != 1 || st != 0) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, yahoo_https_status_parse(st), NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, yahoo_https_status_parse(st), NULL);
 		goto fail;
 	}
 	
 	if ((had->token = yahoo_ha_find_key(req->reply_body, "ymsgr")) == NULL) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 3001, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 3001, NULL);
 		goto fail;
 	}
 	
-	return yahoo_https_auth_init(had);
+	yahoo_https_auth_init(had);
+	return;
 	
 fail:
@@ -2409,10 +1902,10 @@
 
 	if (req->status_code != 200) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 2000 + req->status_code, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 2000 + req->status_code, NULL);
 		goto fail;
 	}
 	
 	if (sscanf(req->reply_body, "%d", &st) != 1 || st != 0) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, yahoo_https_status_parse(st), NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, yahoo_https_status_parse(st), NULL);
 		goto fail;
 	}
@@ -2421,5 +1914,5 @@
 	    (yd->cookie_t = yahoo_ha_find_key(req->reply_body, "T")) == NULL ||
 	    (crumb = yahoo_ha_find_key(req->reply_body, "crumb")) == NULL) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 3002, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 3002, NULL);
 		goto fail;
 	}
@@ -2454,50 +1947,51 @@
 }
 
-static void yahoo_process_auth(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_auth(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *seed = NULL;
-	char *sn   = NULL;
+	char *sn = NULL;
 	YList *l = pkt->hash;
 	int m = 0;
+	struct yahoo_data *yd = yid->yd;
 
 	while (l) {
 		struct yahoo_pair *pair = l->data;
-		if (pair->key == 94)
+
+		switch (pair->key) {
+		case 94:
 			seed = pair->value;
-		if (pair->key == 1)
+			break;
+		case 1:
 			sn = pair->value;
-		if (pair->key == 13)
+			break;
+		case 13:
 			m = atoi(pair->value);
+			break;
+		}
 		l = l->next;
 	}
 
-	if (!seed) 
-		return;
-
-	switch (m) {
-		case 0:
-			yahoo_process_auth_pre_0x0b(yid, seed, sn);
-			break;
-		case 1:
-			yahoo_process_auth_0x0b(yid, seed, sn);
-			break;
-		case 2:
-			yahoo_process_auth_0x10(yid, seed, sn);
-			break;
-		default:
-			/* call error */
-			WARNING(("unknown auth type %d", m));
-			yahoo_process_auth_0x0b(yid, seed, sn);
-			break;
-	}
-}
-
-static void yahoo_process_auth_resp(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+	if (!seed)
+		return;
+
+	if (m==2)
+		yahoo_https_auth(yid, seed, sn);
+	else {
+		/* call error */
+		WARNING(("unknown auth type %d", m));
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			YAHOO_LOGIN_UNKNOWN, NULL);
+	}
+}
+
+static void yahoo_process_auth_resp(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
 	char *login_id;
 	char *handle;
-	char *url=NULL;
-	int  login_status=0;
+	char *url = NULL;
+	int login_status = -1;
 
 	YList *l;
@@ -2515,11 +2009,13 @@
 	}
 
-	if(pkt->status == 0xffffffff) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, login_status, url);
-	/*	yahoo_logoff(yd->client_id);*/
-	}
-}
-
-static void yahoo_process_mail(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+	if (pkt->status == YPACKET_STATUS_DISCONNECTED) {
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			login_status, url);
+		/*      yahoo_logoff(yd->client_id); */
+	}
+}
+
+static void yahoo_process_mail(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2547,10 +2043,44 @@
 		char from[1024];
 		snprintf(from, sizeof(from), "%s (%s)", who, email);
-		YAHOO_CALLBACK(ext_yahoo_mail_notify)(yd->client_id, from, subj, count);
-	} else if(count > 0)
-		YAHOO_CALLBACK(ext_yahoo_mail_notify)(yd->client_id, NULL, NULL, count);
-}
-
-static void yahoo_process_contact(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		YAHOO_CALLBACK(ext_yahoo_mail_notify) (yd->client_id, from,
+			subj, count);
+	} else if (count > 0)
+		YAHOO_CALLBACK(ext_yahoo_mail_notify) (yd->client_id, NULL,
+			NULL, count);
+}
+
+static void yahoo_process_new_contact(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	struct yahoo_data *yd = yid->yd;
+	char *me = NULL;
+	char *who = NULL;
+	char *msg = NULL;
+	int online = -1;
+
+	YList *l;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		if (pair->key == 4)
+			who = pair->value;
+		else if (pair->key == 5)
+			me = pair->value;
+		else if (pair->key == 14)
+			msg = pair->value;
+		else if (pair->key == 13)
+			online = strtol(pair->value, NULL, 10);
+	}
+
+	if (who && online < 0)
+		YAHOO_CALLBACK(ext_yahoo_contact_added) (yd->client_id, me, who,
+			msg);
+	else if (online == 2)
+		YAHOO_CALLBACK(ext_yahoo_rejected) (yd->client_id, who, msg);
+}
+
+/* UNUSED? */
+static void yahoo_process_contact(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
